##  Copyright (C) 2006  Emidio Capriotti
## 
##  This program and all program in this package are free software;
##  you can redistribute it and/or modify it under the terms of the
##  GNU General Public License as published by the Free Software 
##  Foundation; either version 2 of the License, or (at your option)
##  any later version.
## 
##  This program is distributed in the hope that it will be useful,
##  but WITHOUT ANY WARRANTY; without even the implied warranty of
##  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
##  GNU General Public License for more details.
## 
##  You should have received a copy of the GNU General Public License
##  along with this program; if not, write to the Free Software
##  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA
## 
##  contacts: Emidio Capriotti
##	      c/o Prof. Rita Casadio		
##            e-mail: emidio@biocomp.unibo.it
##            Dept. of Biology
##            University of Bologna
##            via Irnerio 42
##            40126 Bologna
##            Italy
## 
##  Last Update July 2009	
##

try:
	import psyco
except:
	pass


lh='VLIMFWYGAPSTCHRKQEND'
allr=['V', 'L', 'I', 'M', 'F', 'W', 'Y', 'G', 'A', 'P',\
	'S', 'T', 'C', 'H', 'R', 'K', 'Q', 'E', 'N', 'D']



prese='\n'+78*'*'+'\n**'+74*' '+'**\n'+\
      '**'+33*' '+ 'PhD-SNP'+34*' '+\
      '**\n**'+19*' '+'Predictor of human Deleterious SNPs'+\
      20*' '+'**\n**'+74*' '+'**\n'+78*'*'+'\n\n'

leg= '      WT:  Aminoacid in Wild-Type Protein\n'+\
     '      NEW: New Aminoacid after Mutation\n'+\
     '      RI:  Reliability Index\n'+\
     '      Effect:\n'+\
     '             Neutral: Neural Polymorphism\n'+\
     '             Disease: Disease-related Polymorphism\n'    


cite='\n'+78*'*'+'\n'+\
     '** Capriotti E, Calabrese R, Casadio R. (2006) Predicting the insurgence of **\n'+\
     '** human genetic diseases associated to single point protein mutations with **\n'+\
     '** support vector machines and evolutionary information. Bioinformatics. 22 **\n'+\
     '** 2729-2734.'+63*' '+'**\n'+\
     78*'*'+'\n'


def checkSequence(seqfile,position,mutant,tmpdir=''):
        # Control Sequence file
        err=''
	rval=str(random.random())[2:]
	dirout=tmpdir+'P-SNP'+rval+'/'
	o=getstatusoutput('mkdir '+dirout)
	if o[0]!=0: err=o[1]
        try:
                f=open(seqfile,'r').read()
        except: 
                err=' Uncorrect Sequence file'
        seq=''
        if err=='':
		for i in f:
			if lh.find(i)!=-1: seq=seq+i.upper()
        if seq!='' and len(seq)<19: err=' Sequence too Short: Minimal length 19 Residues '
        if err=='':
                if int(position)<=0 or int(position)>len(seq): err=' Incorrect Sequence position '
        if err=='':
                if seq[int(position)-1]==mutant[0].upper() or lh.find(mutant[0].upper())==-1 : err='Incorrect mutant residue'
	if err=='':
		fileout=dirout+'fileseq.txt'
		open(fileout,'w').write(seq)
	else:
		fileout=''
		if os.path.isdir(dirout): getstatusoutput('rm -r '+dirout)
        return err,fileout



if (__name__  == '__main__'):
    import sys, string, os, random
    from commands import getstatusoutput
    vinp=sys.argv
    cmd=vinp[0]
    print prese
    progpath=cmd[:cmd.find('PhD-SNP.py')]
    if progpath=='': progpath=os.getcwd()+'/' 
    tmpout=progpath+'tmp/'
    #print progpath
    dbfile=open(progpath+'Tools/ENVIRON','r').read().split('PhD-SNPdb=')[1].strip()
    os.environ['PhD-SNP']=progpath
    os.environ['PhD-SNPdb']=dbfile
    try:
	PDBT=progpath+'Tools/'
	svmprofpath=progpath+'SvmData/Prof/'
	svmseqpath=progpath+'SvmData/Seq/'
	svmseqprofpath=progpath+'SvmData/SeqProf/'
    	sys.path.append(PDBT)
	sys.path.append(svmseqpath)
	sys.path.append(svmprofpath)
	sys.path.append(progpath)
	from DisMutant import  SvmSeqOutput, SvmProfOutput, SvmSeqProfOutput, makeHSSP
	try:
		psyco.bind(SvmSeqOutput)
		psyco.bind(SvmProfOutput)
	except:
		pass
    except:
    	PDBT=progpath+'Tools\\'
	svmseqpath=progpath+'SvmData\\Seq\\'
	svmprofpath=progpath+'SvmData\\Prof\\'
	svmseqprofpath=progpath+'SvmData\\SeqProf\\'
    	sys.path.append(PDBT)
	sys.path.append(svmseqpath)
	sys.path.append(svmprofpath)
	sys.path.append(progpath)
	from DisMutant import  SvmSeqOutput, SvmProfOutput, SvmSeqProfOutput, makeHSSP
	try:
        	psyco.bind(SvmSeqOutput) 
		psyco.bind(SvmProfOutput)
	except:
		pass

    if len(vinp)>4 and vinp[1][:4]=='-seq':
		seqfile=vinp[2]
		position=vinp[3]
                newres=string.upper(vinp[4][0])
		try:
			cv=string.upper(vinp[5])
			if cv=='TRUE': 
				cv=True
			else:
				cv=False
		except:
			cv=False
		if vinp[1]=='-seq':
                        opt='S'
			err,okseq=checkSequence(seqfile,position,newres,tmpout)
			if err=='':
				SvmSeqOutput(okseq,position,newres,9,cv,svmseqpath)
			else:
				print 5*' ','Error:',err
                else:
			err,okseq=checkSequence(seqfile,position,newres,tmpout)
			if err=='':
				outhssp=makeHSSP(seqfile,okseq+'.hssp')
				if outhssp=='':
					if vinp[1]=='-seqp':
						opt='P'
						outprof=SvmProfOutput(okseq,okseq+'.hssp',position,newres,cv,svmprofpath)
						if outprof!=[]:
							pseq=[]
							for j in outprof:
								pseq.append(j[2])
								SvmSeqOutput(okseq,position,pseq,9,cv,svmprofpath)
					else:
						opt='B'
						SvmSeqProfOutput(okseq,okseq+'.hssp',position,newres,9,cv,svmseqprofpath)
				else:
					print 5*' ','Error:',outhssp
			else:
				print 5*' ','Error:',err
		odir=string.join(okseq.split('/')[:-1],'/')
		if os.path.isdir(odir): getstatusoutput('rm -r '+odir)

    else:
		print 'Prediction Using Sequence Information:'
		print ' - Predict Deleterious SNPs'
		print '   python PhD-SNP.py -seq  seqfile position newres'
		print ' - Predict Deleterious SNPs by Sequence or Evolutionary Information'
		print '   python PhD-SNP.py -seqp seqfile position newres\n'
		print ' - Predict Deleterious SNPs by Sequence and Evolutionary Information'
                print '   python PhD-SNP.py -seqb seqfile position newres\n'
		vexit=''
		while string.upper(vexit)!='Y':
			opt=''
			kpred='SEQ'
			while opt=='':
				opt=string.upper(raw_input('SVMs Input Data (S=Sequence, P=Sequence or Profile, B=Sequence and Profile)='))
				print opt
			if opt!='S' and  opt!='P': opt='B'
			if kpred=='SEQ':
				seqfile=''
				seqfile=raw_input('Sequence file name: ')
			if opt!='S' and opt!='P': opt='B'
			position=''
			while position=='':
				try:
					position=int(raw_input('Residue position number: '))
					position=str(position)
				except:
					position=''
			newres='X'
			while lh.find(newres)==-1:
				newres=string.upper(raw_input('New residue: '))
			cv=''
			while cv=='':
				try:
					cv=string.upper(raw_input('Multi-SVM (N/Y): '))
					if cv=='Y': 
						cv=True
					else:
						cv=False
				except:
					cv=False
			if opt=='S':
				err,okseq=checkSequence(seqfile,position,newres,tmpout)
				if err=='':
					SvmSeqOutput(seqfile,position,newres,9,cv,svmseqpath)
				else:
					print 5*' ','Error: ',err
			else:
				err,okseq=checkSequence(seqfile,position,newres,tmpout)
				if err=='':
					outhssp=makeHSSP(okseq,okseq+'.hssp')
					if outhssp=='':
						if opt=='P':
							outprof=SvmProfOutput(okseq,okseq+'.hssp',position,newres,cv,svmprofpath)
							if outprof!=[]:
								pseq=[]
								for j in outprof:
									pseq.append(j[2])
									SvmSeqOutput(okseq,position,pseq,9,cv,svmprofpath)

						else:
							SvmSeqProfOutput(okseq,okseq+'.hssp',position,newres,9,cv,svmseqprofpath)
					else:
						print 5*' ','Error:',outhssp
				else:
					print 5*' ','Error: ',err
			odir=string.join(okseq.split('/')[:-1],'/')
			if os.path.isdir(odir): getstatusoutput('rm -r '+odir)
			vexit=raw_input('Exit [N/Y]: ') 
    print '\n'+leg
    print cite
