#!/usr/bin/perl -w
#
# legge in input:
# legge file con la sequenza e l'output di blast con gli
# allineamenti
# il profilo che crea e' del tipo Prof{"$i,$c"} = 
# 
# Modificato il 4/12/01 per stampare il numero di sequenze
# allineate per ogni prosizione
# 

@hsspAA= (V,L,I,M,F,W,Y,G,A,P,S,T,C,H,R,K,Q,E,N,D);
#@blastAA=(A,R,N,D,C,Q,E,G,H,I,L,K,M,F,P,S,T,W,Y,V);

if($#ARGV <1 ) { 
   die "Sintax $0 <fileseq> <blastout_with_alignments> [identity] \n";
}

if($#ARGV >=2) { $Id=$ARGV[2];}
else { $Id=100;}

$Fileseq=$ARGV[0];
$Fileblast=$ARGV[1];
%Profile=();
@NumberOfAlignedSequence=();
$len=&createprof($Fileseq,*Profile,*NumberOfAlignedSequence);
open(F,"grep \"No hits found\" $Fileblast | wc |") || die "Can't open $F\n";
$_=<F>;
$n=(split(" ",$_))[0];
#   
close(F);
print "ID Pseudo hssp file.\n";
unless($n>0) {
   &getprof($Fileblast,*Profile,*NumberOfAlignedSequence);
   $numSeq=&printNameSeq($Fileblast) ;
}
print "NALIGN\t$numSeq\n";
&printprofile($len,*Profile,*NumberOfAlignedSequence);
print "//\n";

###################################

################
#
#
#  
###############
sub printNameSeq {
   local($f)=@_;
   local($F,$line,$set,$num);

   $num=0;
   $F="F$f";
   $set="";
   open($F,"$f") || die "Can't open $F\n";
   do{ 
      $line=<$F>;
   }until($line=~/Sequences producing significant alignments/);
   do{
      $line=<$F>; 
      unless($line=~/^>/) { $set.="SEQ $line";$num++;} 
   }until($line=~/^>/);
   close($F);
   print $set;
   if($num>0) {$num-=2;}
   return($num);
}
################




################
#
#
#
###############
sub printprofile {
   local($alen,*prof,*No)=@_;
   local($i,$j,$r);
   local($seq,$pdb,@a,$no,$nd,$ent,$rent,$cons);
   local($MAXENT,$ni);


#   $MAXENT=log(20)/log(2);     
   $MAXENT=log(20);

# format
   $~= "TOPPROFILE";
   print "## ";
   write;
# format
   $~= "PROFILE";

   for($i=0; $i< $alen; $i++) {
      for($j=0,$r=0; $j <=$#hsspAA; $j++) {
         $r+=$prof{"$i;$hsspAA[$j]"};
      }
      $ent=0;
      for($j=0; $j <=$#hsspAA; $j++) {
         if($r >0) {
             $a[$j]=int(100*($prof{"$i;$hsspAA[$j]"}/$r+0.005));
#             $a[$j]=$prof{"$i;$hsspAA[$j]"};
             $rent=$prof{"$i;$hsspAA[$j]"}/$r;
             if($rent) {
                 $ent+=-$rent*log($rent);
             }
         }
         else {
             $a[$j]=0;
         }
      } 
      $rent=sprintf("%d",100*($ent/$MAXENT));
      $pdb=$seq=$i+1;
      $no=$No[$i];
      $cons=$nd=$ni=0;
      write;
#      print "\n";
   } 

}
format TOPPROFILE =
SEQUENCE PROFILE AND ENTROPY
 SeqNo PDBNo   V   L   I   M   F   W   Y   G   A   P   S   T   C   H   R   K   Q   E   N   D  NOCC NDEL NINS ENTROPY RELENT WEIGHT
.

format PROFILE =                                                                            
@>>>>@>>>>   @>> @>> @>> @>> @>> @>> @>> @>> @>> @>> @>> @>> @>> @>> @>> @>> @>> @>> @>> @>> @>>>>@>>>>@>>>>  @#.###   @>>>@##.##  
$seq,$pdb,   $a[0],$a[1],$a[2],$a[3],$a[4],$a[5],$a[6],$a[7],$a[8],$a[9],$a[10],$a[11],$a[12],$a[13],$a[14],$a[15],$a[16],$a[17],$a[18],$a[19],$no,$nd,$ni,$ent,$rent,$cons
.
###############



################
#
#
#  
###############
sub getprof {
   local($f,*Profile,*No)=@_;
   local($F,$i,$s1,$s2,$b);
   local($strr,$nround,$conv,$match);
   my($identity);

   $nround=0;
   $match="Matrix:";
   $F="F$f";
#
#   open($F,"grep 'Results from round ' $f | wc |") || die "Can't open $F\n";
   open($F,"grep 'Results from round ' $f | wc |") ;
   $_=<$F>;
   $nround=(split(" ",$_))[0];
#   print "NR $nround\n";
   close($F);
   $strr="Results from round $nround";
#   if($nround > 1) { $match=$match1; $matchsec=$match2;}
#   else { $match=$match0; $matchsec=$match0end; }
#
   $identity=100;
   if($nround>0) {
       open($F,"grep CONVERGED  $f | wc |") || die "Can't open $F\n";
       $_=<$F>;
       $conv=(split(" ",$_))[0];
       close($F);

       open($F,"$f") || die "Can't open $F\n";
       do{
         $_=<$F>;
         if(eof($F)) { die "EOF 1";}
       } while(!/$strr/); # cerca fino all'ultimo round
       do{
         $_=<$F>;
         if(/Identities = \d+\/\d+ \((\d+)\%\)\,/) { $identity=$1;}
         if($identity <= $Id)  {
            if(/^Query:/) { @v=split; $b=$v[1]; $s1=$v[2]; }
            if(/^Sbjct:/) { @v=split; $s2=$v[2]; &updateprof($b,$s1,$s2,*No);}
         } 
         if(eof($F)) { die "EOF 2";}
       } while(!/$match/); # cerca fino al match
       close($F);
   }
   else {
       open($F,"$f") || die "Can't open $F\n";
       do{
         $_=<$F>;
         if(eof($F)) { die "EOF 2";}
         if(/Identities = \d+\/\d+ \((\d+)\%\)\,/) { $identity=$1;}
         if($identity <= $Id)  {
            if(/^Query:/) { @v=split; $b=$v[1]; $s1=$v[2]; }
            if(/^Sbjct:/) { @v=split; $s2=$v[2]; &updateprof($b,$s1,$s2,*No);}
         }
         if(eof($F)) { die "EOF 1";}
       } while(!/$match/); # cerca fino al match
       close($F);
   }
   return;
}
###############


###############
#
#
###############
sub updateprof {
   local($b,$s1,$s2,*No)=@_;
   local($alph,$alph2,$i,$j,$l,$c1,$c2);

   $alph="ARNDCQEGHILKMFPSTWYVBZX";
   $alph2="ARNDCQEGHILKMFPSTWYV";
   $i=$b-1;
   $l=length($s1);
   for($j=0; $j <$l; $j++) {
      $c1=substr($s1,$j,1);
      if($alph=~$c1) {  
         $c2=substr($s2,$j,1);
         if($alph2=~$c2) { 
            $Profile{"$i;$c2"}+=1; 
            $No[$i]++;
         }
         $i++; 
      }
   }
}
###############


###############
#
#
###############
sub createprof {
   local($fname,*prof,*No)=@_;
   local($F,$alph,$st,$len,$i,$j);

   $alph="ARNDCQEGHILKMFPSTWYVBZX";
   $F="F$fname";
   open($F,"$fname") || die "Can't open $F\n";
   $st="";
   while(<$F>) {
     $st.=$_; 
   }
   close($F);
    
   $len=0;
   for($i=0; $i <length($st); $i++) {
      $c=substr($st,$i,1);
      if($alph=~$c) {
        for($j=0; $j <=$#hsspAA; $j++) {
            $prof{"$len;$hsspAA[$j]"}=0;
        }
         $prof{"$len;$c"}=1;
        $len++;
      }
      $No[$i]=0; # number of aligned sequence in position $i
   }
   return($len);
}
###############
